package antonio.calculadoradedivisas;


import android.app.ProgressDialog;
import android.content.Context;
import android.content.pm.ActivityInfo;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;

import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.List;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

public class MainActivity extends AppCompatActivity {

    private List<String> divisas;
    private double equivale;
    private Spinner spinner;
    private Spinner spinner2;
    private EditText numberEditText;
    private TextView resultadoTextView;
    private double resulFinal;
    private Context context;
    private ArrayAdapter<String> adapter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);

        spinner = (Spinner)findViewById(R.id.theSpinner);
        spinner2 = (Spinner)findViewById(R.id.theSpinner2);
        numberEditText = (EditText)findViewById(R.id.numberEditText);
        resultadoTextView = (TextView)findViewById(R.id.resultadoTextView);
        context = getApplicationContext();

        Button calcularButton = (Button)findViewById(R.id.calcularButton);
        calcularButton.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                try {
                    new ConvertirDivisas().execute();
                } catch (Exception e) {
                }
            }
        });
        new LlamadaServer().execute();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        int id = item.getItemId();
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    public void obtenerPaises() throws Exception {
        URL url = new URL("http://www.webservicex.net/CurrencyConvertor.asmx?WSDL");
        SAXParserFactory fabrica = SAXParserFactory.newInstance();
        SAXParser parser = fabrica.newSAXParser();
        XMLReader lector = parser.getXMLReader();
        ManejadorXML manejadorXML = new ManejadorXML();
        lector.setContentHandler(manejadorXML);
        lector.parse(new InputSource(url.openStream()));
        divisas = manejadorXML.getTotalResults();
    }

    public void calcular() throws Exception{
        String pagina = "";
        String resultado = "";
        resultado = "";

        URL llamada = new URL("http://www.webservicex.net/CurrencyConvertor.asmx/ConversionRate?FromCurrency="
                + spinner.getSelectedItem().toString() + "&ToCurrency=" + spinner2.getSelectedItem().toString());
        HttpURLConnection conexion = (HttpURLConnection) llamada.openConnection();

        if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK){
            BufferedReader reader = new BufferedReader(new InputStreamReader(conexion.getInputStream()));
            String linea = reader.readLine();
            while (linea != null) {
                pagina += linea;
                linea = reader.readLine();
                int ini = pagina.indexOf("T/");

                if (ini != -1) {
                    int fin = pagina.indexOf("\"", ini + 4);
                    resultado = pagina.substring(ini + 4, pagina.lastIndexOf("<"));
                    resulFinal = Float.valueOf(resultado.toString()) *
                            Float.valueOf(numberEditText.getText().toString());
                } else {
                    resultado = "";
                }
                resultado="";
            }
            reader.close();

        }
    }

    class LlamadaServer extends AsyncTask<Void, Void, Void>{

        private ProgressDialog progreso;

        @Override protected void onPreExecute() {
            progreso = new ProgressDialog(MainActivity.this);
            progreso.setProgressStyle(ProgressDialog.STYLE_SPINNER);
            progreso.setMessage("Obteniendo divisas...");
            progreso.setCancelable(false);
            progreso.show();
        }

        @Override
        protected Void doInBackground (Void... nada){
            try {
                obtenerPaises();
            }
            catch (Exception e) {
                System.out.println("Error obteniendo paises");
            }
            return null;
        }

        @Override
        protected void onPostExecute(Void nada) {
            progreso.dismiss();

            adapter = new ArrayAdapter<String>(context, android.R.layout.simple_spinner_dropdown_item, divisas);
            spinner.setAdapter(adapter);
            spinner2.setAdapter(adapter);

        }

        @Override
        protected void onCancelled() {
            progreso.dismiss();
        }
    }

    class ConvertirDivisas extends AsyncTask<Void, Void, Void> {

        private ProgressDialog progreso;

        @Override protected void onPreExecute() {
            progreso = new ProgressDialog(MainActivity.this);
            progreso.setProgressStyle(ProgressDialog.STYLE_SPINNER);
            progreso.setMessage("Calculando conversión...");
            progreso.setCancelable(false);
            progreso.show();
        }

        @Override
        protected Void doInBackground (Void... nada){
            try {
                calcular();
            }
            catch (Exception e) {
                System.out.println("Error obteniendo resultado ConvertirDivisas");
            }
            return null;
        }

        @Override
        protected void onPostExecute(Void nada) {
            progreso.dismiss();
            resultadoTextView.setText(String.format("%.2f", resulFinal));
        }

        @Override
        protected void onCancelled() {
            progreso.dismiss();
        }
    }

}





























